/**
 * ...
 * @author flasheasy
 */

package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.easing.*;
	import com.greensock.loading.ImageLoader;
	import com.greensock.loading.LoaderMax;
	import com.greensock.events.LoaderEvent;
	import com.greensock.plugins.AutoAlphaPlugin;
	import com.greensock.loading.display.*;
	import com.greensock.plugins.TweenPlugin;
	import com.greensock.plugins.ColorTransformPlugin;
	import com.greensock.plugins.TintPlugin;
	import flash.geom.Rectangle;
	import flash.display.LoaderInfo;
	import flash.net.URLRequest;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	
	public class Viewer360 extends MovieClip 
	{
		// Activating plugins
		TweenPlugin.activate([AutoAlphaPlugin, ColorTransformPlugin, TintPlugin]);
		
		// define mainMc. mainMc contains all other movie clips in the scene
		private var mainMc:MovieClip = new MovieClip();
		
		// define imageHolder. imageHolder contains the loaded images
		private var imageHolder:MovieClip = new MovieClip();
		
		// define imageMask. It masks the imageHolder. It's an instance of "BlackBox" - a movie clip in the library. 
		private var imageMask:MovieClip = new BlackBox();
		// define backgroundBox. It's an instance of "BlackBox" - a movie clip in the library. 
		private var backgroundBox:MovieClip = new BlackBox();
		// define slideRotation. Rotation slider. It's an instance of "SlideRotation" - a movie clip in the library. 
		private var slideRotation:MovieClip = new SlideRotation();
		// define slideZoom. Zoom slider. It's an instance of "SlideZoom" - a movie clip in the library. 
		private var slideZoom:MovieClip = new SlideZoom();
		// define blackBox. Dims the image when the preloader is active. It's an instance of "BlackBox" - a movie clip in the library. 
		private var blackBox:MovieClip = new BlackBox();
		// define loaderMc. The preloader. It's an instance of "LoaderMc" - a movie clip in the library. 
		private var loaderMc:MovieClip = new LoaderMc();
		// define errorMc. Shows an error message when external variables are not loaded. It's an instance of "ErrorMc" - a movie clip in the library. 
		// it's used for debugging purposes.
		private var errorMc:MovieClip = new ErrorMc();
		
		// define imagesArray. All names of the images that need to be loaded.
		private var imagesArray:Array = new Array();
		
		// define imagesFolder. Directory where the images are.
		private var imagesFolder:String;
		// define imagesMcArray. The movie clips in which the images are loaded.
		private var imagesMcArray:Array = new Array();
		// define currentVisibleImage. The instance name of the movie clip which contains the current visible image.
		private var currentVisibleImage;
		
		// loads ImageLoaders in a queue
		private var queue:LoaderMax;
		
		// ==== Settings Variables. "c" for configuration =====
		private var cXMLObject:XML
		// xml file that contains the settings
		private var cXMLFile:String = "viewerConfing.xml";
		// urlLoader for the xml file
		private var cXMLLoader = new URLLoader();
		// "true" or "false" .. to use the image directory and name from the XML file or from the SWFObject external variables.
		private var cXMLUse:String;
		// viewer height
		private var cViewerH:Number;
		// viewer width
		private var cViewerW:Number;
		// color of button and the path of the slider
		private var cSlidersColor:String;
		// color of the slider background
		private var cSlidersBackgroundColor:String;
		// transparency of the slider background
		private var cSlidersBackgroundTransparency:Number;
		// background color
		private var cBackgroundColor:String;
		// zoom slider enable disable
		private var cZoomSliderEnable:String;
		// zoom how many times is possible to zoom the image
		private var cZoomAmount:Number;
		// zoom slider length
		private var cZoomSlidePathLength:Number;
		// rotation slider length
		private var cRotationSlidePathLength:Number;
		//color of the loader bar main elements
		private var cLoaderBarColor:String;
		//color of the loader bar background elements
		private var cLoaderBarBackground:String;
		//loader text color
		private var cLoaderTextColor:String;
		//loader background color. The background of the loader covers the viewer UI and images when loading
		private var cLoaderBackgroundColor:String;
		// how much of the viewer to be visible when loading / the background of the loader covers the viewer UI and images when loading
		private var cLoaderBackgroundTransparency:Number;
		// mouse wheel on/off
		private var cMouseWheel:String;
		// mouse wheel speed
		private var cMouseWheelSpeed:Number;
		// images directory
		private var cImagesDir:String;
		// image file name
		private var cImageFileName:String;
		// image file format
		private var cImageFormat:String;
		// number of images in the directory
		private var cNumberOfImages:Number;
		
		//space between the slider's path and background
		private var slidersPadding:Number = 10;
		//drag variables
		private var rectangleObject:Object = new Object();
		private var imageDragRectangle:Rectangle;
		
		//short for slideRotation.thumb
		private var thumbR:MovieClip;
		
		//short for slideZoom.thumb
		private var thumbZ:MovieClip;
		
		//short for slideZoom.path
		private var pathZ:MovieClip;
		private var pathZLength:Number;
		
		//short for slideRotation.path
		private var pathR:MovieClip;
		private var pathRLength:Number;
		
		//current visible image 
		private var currentImage;
		
		
		public function Viewer360():void 
		{
			//align top left / stop scaling
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
		}
		private function onAddedToStage(event:Event = null):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
			// adding objects to stage
			addChild(mainMc);
			//hiding everything before it arranges
			mainMc.visible = false;
			mainMc.addChild(backgroundBox);
			mainMc.addChild(imageHolder);
			mainMc.addChild(imageMask);
			mainMc.addChild(slideRotation);
			mainMc.addChild(slideZoom);
			mainMc.addChild(blackBox);
			mainMc.addChild(loaderMc);
			
			// masking the imageHolder
			imageHolder.mask = imageMask;

			
			// checking if the configuration XML file is set form external source
			if(LoaderInfo(this.root.loaderInfo).parameters["externalConfigurationFile"]){
				var externalConfigurationFile:String = LoaderInfo(this.root.loaderInfo).parameters["externalConfigurationFile"];
				cXMLFile = externalConfigurationFile;
				// debuging lines
				//mainMc.addChild(errorMc);
				//errorMc.textField.text = cXMLFile;
			}
			
			// loading configuration
			loadConfigXML(cXMLFile);
		}
		// load the configuration from the XML file
		private function loadConfigXML(_xmlFile:String):void
		{
			cXMLLoader.load(new URLRequest(_xmlFile));
			cXMLLoader.addEventListener(Event.COMPLETE, onConfigXMLLoaded);
		}
		
		// apply the settings form the configuration XML file
		private function onConfigXMLLoaded(e:Event):void
		{
			cXMLObject = new XML(e.target.data);
			
			cXMLUse = cXMLObject.xmlSource;
			cSlidersColor = cXMLObject.slidersColor;
			cZoomSliderEnable = cXMLObject.zoomSliderEnable;
			cZoomAmount = cXMLObject.zoomAmount;
			cMouseWheel = cXMLObject.mouseWheel;
			cMouseWheelSpeed = cXMLObject.mouseWheelSpeed;
			cBackgroundColor = cXMLObject.backgroundColor;
			cSlidersBackgroundColor = cXMLObject.slidersBackgroundColor;
			cSlidersBackgroundTransparency = cXMLObject.slidersBackgroundTransparency / 100;
			cZoomSlidePathLength = cXMLObject.zoomSlidePathLength;
			cRotationSlidePathLength = cXMLObject.rotationSlidePathLength;
			cLoaderBarColor = cXMLObject.loaderBarColor;
			cLoaderBarBackground = cXMLObject.loaderBarBackgroundColor;
			cLoaderTextColor = cXMLObject.loaderTextColor;
			cLoaderBackgroundColor = cXMLObject.loaderBackgroundColor;
			cLoaderBackgroundTransparency = cXMLObject.loaderBackgroundTransparency;
			
			cViewerH = cXMLObject.viewerHeight;
			cViewerW = cXMLObject.viewerWidth;
			
			// if XML settings is "true" apply image path and names form the XML file
			if (cXMLUse == "true") {
				
				cImagesDir = cXMLObject.imagesDir;
				cImageFileName = cXMLObject.imageFileName;
				cImageFormat = cXMLObject.imageFileFormat;
				cNumberOfImages = Number(cXMLObject.numberOfImages) + 1;
				cLoaderBackgroundTransparency = cXMLObject.loaderBackgroundTransparency;
				
				for (var i = 1; i < cNumberOfImages; i++) {
					var arrayElement:String = cImageFileName + i + "." + cImageFormat;
					imagesArray.push(arrayElement);
				}
				
			}// else use the external variables in the HTML ( SWFObject )
			else {
				var externalImageArray:String = LoaderInfo(this.root.loaderInfo).parameters["externalImageArray"];
				var externalImageDir:String = LoaderInfo(this.root.loaderInfo).parameters["externalImageDir"];
				
				if (externalImageArray && externalImageDir) {
					imagesArray = externalImageArray.split(",");
					cNumberOfImages = imagesArray.length;
					cImagesDir = externalImageDir;
				} else {
					// if there is a problem loading the external variables show an error
					mainMc.addChild(errorMc);
					errorMc.textField.text = "Error loading external variables! If you have set the <xmlSource> to false you must start the HTML file to test the result. Make sure that you set the right directory and the names of the images in the array are separated by comma and there are no spaces as well.";
				}
				
			}
			
			if (cZoomSliderEnable != "true") {
				slideZoom.visible = false;
			}
			imagesFolder = cImagesDir;
			
			// Set UI initial alpha
			loaderMc.alpha = 0;
			blackBox.alpha = cLoaderBackgroundTransparency/100;
			slideRotation.alpha = 0;
			slideZoom.alpha = 0;
			
			// Set background color
			TweenLite.to(backgroundBox, .01, { colorTransform: { tint:cBackgroundColor, tintAmount:1 }} );
			// Set loader background color
			TweenLite.to(blackBox, .01, { colorTransform: { tint:cLoaderBackgroundColor, tintAmount:1 }} );
			// Set loader bar color
			TweenLite.to(loaderMc.loaderBar, .01, { colorTransform: { tint:cLoaderBarColor, tintAmount:1 }} );
			// Set loader text color
			TweenLite.to(loaderMc.loaderField, .01, { colorTransform: { tint:cLoaderTextColor, tintAmount:1 }} );
			// Set loader bar background color
			TweenLite.to(loaderMc.loaderBarBg, .01, { colorTransform: { tint:cLoaderBarBackground, tintAmount:1 }} );
			// Set sliders color
			var slidersArray:Array = new Array(slideRotation.thumb.bg, slideZoom.thumb.bg, slideRotation.path, slideZoom.path,slideRotation.icon,slideZoom.icon);
			TweenMax.allTo(slidersArray, .01, { colorTransform: { tint:cSlidersColor, tintAmount:1 }} );
			var slidersBackgroundsArray = new Array(slideRotation.bg, slideZoom.bg);
			TweenMax.allTo(slidersBackgroundsArray, .01, { alpha: cSlidersBackgroundTransparency, colorTransform: { tint:cSlidersBackgroundColor, tintAmount:1 }} );
			
			// Rotation button properties
			thumbR = slideRotation.thumb;
			thumbR.buttonMode = true;
			thumbR.mouseChildren = false;
			thumbR.addEventListener(MouseEvent.MOUSE_DOWN, startDragThumbR);
			
			// Rotation Path properties
			pathR = slideRotation.path;
			slideRotation.path.width = cRotationSlidePathLength;
			pathRLength = cRotationSlidePathLength - thumbR.width;
			
			// Zoom button properties
			thumbZ = slideZoom.thumb;
			thumbZ.buttonMode = true;
			thumbZ.mouseChildren = false;
			thumbZ.addEventListener(MouseEvent.MOUSE_DOWN, startDragThumbZ);
			
			// Zoom path properties
			pathZ = slideZoom.path;
			slideZoom.path.height = cZoomSlidePathLength;
			pathZLength = cZoomSlidePathLength - thumbZ.height;
			
			// arrange UI elemets
			positionUI();
			
			// start loading the images
			loadImages();
			
			
		}
		// arrange UI elemets
		private function positionUI():void
		{
			// Background position
			backgroundBox.height = cViewerH;
			backgroundBox.width = cViewerW;
			// Mask position
			imageMask.height = cViewerH;
			imageMask.width = cViewerW;
			// Rotation slide positioning
			slideRotation.bg.x = - slidersPadding - slideRotation.icon.width;
			slideRotation.bg.width = slideRotation.path.width + slideRotation.icon.width + slidersPadding*2;
			slideRotation.icon.x = - slideRotation.icon.width - slidersPadding / 2;
			slideRotation.x = (cViewerW - slideRotation.width) / 2;
			slideRotation.y = cViewerH - 30;
			
			//Zoom slide position
			slideZoom.bg.y = - slidersPadding;
			slideZoom.bg.height = slideZoom.path.height + slideZoom.icon.height + slidersPadding * 2;
			slideZoom.icon.y = slideZoom.path.height + slidersPadding / 2;
			slideZoom.x = cViewerW - 30;
			slideZoom.y = (cViewerH - slideZoom.height) / 2;
			
			// scale background to i
			blackBox.height = cViewerH;
			blackBox.width = cViewerW;
			//Loader
			TweenLite.to(loaderMc, 1.5, { alpha:1, delay:1 } );
			loaderMc.x = (cViewerW - loaderMc.width) / 2;
			loaderMc.y = cViewerH / 2;
			// show UI
			mainMc.visible = true;
		}
		// load images
		private function loadImages():void
		{
			LoaderMax.activate([ImageLoader]);
			queue = LoaderMax.parse(imagesArray, 
								  {maxConnections:2, 
								   auditedSize: true,
								   onComplete:onImagesLoaded,
								   onProgress:onImageProgress,
								   onChildComplete:onChildImageLoaded},
								  {width:cViewerW, 
								   height:cViewerH, 
								   scaleMode:"proportionalInside"
								   });
			queue.prependURLs(imagesFolder);
			LoaderMax.prioritize(queue.getContent(imagesFolder + imagesArray[0]).name)
			queue.load();
		}
		// scale loader bar when the images are loading
		private function onImageProgress(e:LoaderEvent):void
		{
			// loader bar scale
			loaderMc.loaderBar.scaleX = e.target.progress;
			// loader text %
			loaderMc.loaderField.text = Math.round(e.target.progress * 100) + "%";
		}
		// add images in imageHoder when loaded. Show the UI.
		private function onImagesLoaded(e:LoaderEvent):void
		{
			var contents:Array = e.target.content;
			var currentContent:ContentDisplay;
			for (var i:int = 0; i < contents.length; i++) {
				currentContent = contents[i];
				currentContent.visible = false;
				imageHolder.addChild(currentContent);
				imagesMcArray.push(currentContent);
			}
			
			imagesMcArray[0].visible = true;
			currentVisibleImage = imagesMcArray[0];
			
			if (cMouseWheel == "true"){
				//Start Mouse Wheel event
				stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
			} else {
				
			}
			
			//Remove the loader and show UI
			TweenLite.killTweensOf(loaderMc);
			TweenLite.to(loaderMc, .5, { autoAlpha:0 } );
			TweenLite.to(blackBox, .5, { autoAlpha:0, delay:.5 } );
			TweenLite.to(slideRotation, .2, { alpha:1, delay:.5 } );
			TweenLite.to(slideZoom, .2, { alpha:1, delay:.5 } );
			
		}
		// add and display the fisrt picture when loaded
		private function onChildImageLoaded(e:LoaderEvent):void
		{
			var firstImageLoaderName = queue.getContent(imagesFolder + imagesArray[0]).name;
			if (e.target.name == firstImageLoaderName) {
				var firstPicture = e.target.content;
				firstPicture.visible = false;
				firstPicture.alpha = 0;
				imageHolder.addChild(firstPicture);
				TweenLite.to(firstPicture, 2, { autoAlpha:1 } );
			}
		}
		// start dragging the button in the rotation slider when it is pressed
		private function startDragThumbR(e:MouseEvent):void
		{
			var eventTarget = e.target;
			var bounds:Rectangle = new Rectangle(0, -thumbR.height/2, pathRLength, 0);
			eventTarget.startDrag(false, bounds);
			
			// bug fix ( dragging ThumbR and ThumbZ stops when image button is active )
			setStopDragImage();
			
			stage.addEventListener(MouseEvent.MOUSE_UP, stopDragThumbR);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onThumbRMove);
		}
		// stop dragging the button in the rotation slider when it is released
		private function stopDragThumbR(e:MouseEvent):void
		{
			// bug fix ( dragging ThumbR and ThumbZ stops when image button is active )
			// activate the image dragging if needed
			if (imageHolder.scaleX > 1) {
				setStartDragImage();
			}
			
			stage.removeEventListener(MouseEvent.MOUSE_UP, stopDragThumbR);
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, onThumbRMove);
			thumbR.stopDrag();
		}
		// rotate the images
		private function onThumbRMove(e:MouseEvent):void
		{
			// Finding the next image to show
			var nextImageDragDistance:Number = pathRLength / imagesArray.length;
			currentImage = Math.floor(thumbR.x / nextImageDragDistance);
			currentVisibleImage.visible = false;
			imagesMcArray[currentImage].visible = true;
			currentVisibleImage = imagesMcArray[currentImage];
		}
		// start dragging the button in the zoom slider when it is pressed and zoom the image
		private function startDragThumbZ(e:MouseEvent):void
		{
			var eventTarget = e.target;
			var bounds:Rectangle = new Rectangle(thumbZ.width/2, 0, 0, pathZLength);
			eventTarget.startDrag(false, bounds);
			
			// bug fix ( dragging ThumbR and ThumbZ stops when image button is active )
			setStopDragImage();
			
			stage.addEventListener(MouseEvent.MOUSE_UP, stopDragThumbZ);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onThumbZMove);
		}
		// stop dragging the button in the zoom slider when it is released
		private function stopDragThumbZ(e:MouseEvent):void
		{
			// bug fix ( dragging ThumbR and ThumbZ stops when image button is active )
			// activate the image dragging if needed
			if (imageHolder.scaleX > 1) {
				setStartDragImage();
			}else {
				imageHolder.x = 0;
				imageHolder.y = 0;
				imageHolder.scaleX = 1;
				imageHolder.scaleY = 1;
				setStopDragImage();
			}
			
			stage.removeEventListener(MouseEvent.MOUSE_UP, stopDragThumbZ);
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, onThumbZMove);
			thumbZ.stopDrag();
		}
		// zoom in and out the image and restrict it's size to the zoomAmout and the viewer size ( set from the XML )
		private function onThumbZMove(e:MouseEvent = null):void
		{
			var oldWidth = imageHolder.width;
			var oldHeight = imageHolder.height;
			
			var zoomIndex:Number = (((thumbZ.y / pathZLength) * 100) / 100)*cZoomAmount;
			var scaleTo = 1 + zoomIndex;
			imageHolder.scaleX = scaleTo;
			imageHolder.scaleY = scaleTo;
			
			if (Math.abs(imageHolder.x) < (imageHolder.width - cViewerW)) {
				if(imageHolder.x != 0 || oldWidth < imageHolder.width) {
					imageHolder.x = - Math.abs(imageHolder.x - (imageHolder.width - oldWidth) / 2);
				}
			}
			if (Math.abs(imageHolder.y) <= ( imageHolder.height - cViewerH )) {
				if(imageHolder.y != 0 || oldHeight < imageHolder.height) {
					imageHolder.y = - Math.abs(imageHolder.y - (imageHolder.height - oldHeight) / 2);
				}
			}
			if (Math.abs(imageHolder.x) >= (imageHolder.width - cViewerW)) {
				imageHolder.x = cViewerW - imageHolder.width;
			}
			if (Math.abs(imageHolder.y) >= ( imageHolder.height - cViewerH )) {
				imageHolder.y = cViewerH - imageHolder.height;
			} 
		}
		// make dragging the image available and restrict it to the viewer size
		private function setStartDragImage():void
		{
			rectangleObject.x = cViewerW - imageHolder.width;
			rectangleObject.y = cViewerH - imageHolder.height;
			rectangleObject.width = imageHolder.width - cViewerW;
			rectangleObject.height = imageHolder.height - cViewerH;
			
			imageDragRectangle = new Rectangle(rectangleObject.x, rectangleObject.y, rectangleObject.width, rectangleObject.height); 
			
			imageHolder.addEventListener(MouseEvent.MOUSE_DOWN, startDragImage);
			imageHolder.addEventListener(MouseEvent.MOUSE_UP, stopDragImage);
			imageHolder.addEventListener(MouseEvent.MOUSE_OUT, stopDragImage);
			
			imageHolder.buttonMode = true;
			imageHolder.mouseChildren = false;
		}
		// make dragging the image unavailable
		private function setStopDragImage():void
		{
			imageHolder.removeEventListener(MouseEvent.MOUSE_DOWN, startDragImage);
			imageHolder.removeEventListener(MouseEvent.MOUSE_UP, stopDragImage);
			imageHolder.removeEventListener(MouseEvent.MOUSE_OUT, stopDragImage);
			imageHolder.buttonMode = false;
			imageHolder.mouseChildren = false;
		}
		// start dragging the image
		private function startDragImage(e:MouseEvent):void
		{
			imageHolder.startDrag(false, imageDragRectangle);
			//when dragging the image it stops the Mouse Wheel to avoid bugs
			if (cMouseWheel == "true"){
				stage.removeEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
			}
		}
		// stop dragging the image
		private function stopDragImage(e:MouseEvent):void
		{
			imageHolder.stopDrag();
			//when dragging the image it stops the Mouse Wheel to avoid bugs
			if (cMouseWheel == "true"){
				stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
			}
		}
		// zoom in and out with the mouse wheel
		private function onMouseWheel(e:MouseEvent):void
		{
			var wheelToY = thumbZ.y - e.delta*cMouseWheelSpeed;
			if (wheelToY<= 0) 
			{
				wheelToY = 0;
			}
			if (wheelToY >= pathZLength) 
			{
				wheelToY = pathZLength;
			}
			// move smoothly the button in the zoom slider
			TweenLite.to(thumbZ, .3, { y:wheelToY, onUpdate:onThumbZMove, onComplete:onMouseWheelComplete } );
			setStopDragImage();
		}
		// when zooming with the mouse wheel is complete check if the image is bigger than the viewer size and make dragging for it available or not.
		private function onMouseWheelComplete():void
		{
			if (imageHolder.scaleX > 1) {
				setStartDragImage();
			}else {
				imageHolder.x = 0;
				imageHolder.y = 0;
				imageHolder.scaleX = 1;
				imageHolder.scaleY = 1;
				setStopDragImage();
			}
		}
	}
}